import requests
from bs4 import BeautifulSoup
import time 
import os
from google.cloud import pubsub_v1
import datetime

publisher = pubsub_v1.PublisherClient()
topic_name = 'projects/newproj-228110/topics/input'

bse_open_old = 0.0
bse_high_old = 0.0
bse_low_old = 0.0
bse_close_old =0.0
gold_val_old = 0.0
crude_val_old = 0.0
usd_val_old = 0.0

while True:
    
    try:
        bse_url= 'https://www.moneycontrol.com/indian-indices/sensex-4.html'
        res = requests.get(bse_url)        
        result = BeautifulSoup(res.content, "html5lib")
        bse = result.find('p', attrs={'class': 'color_class up-down-text red-color'})
        if bse == None:
            bse = result.find('p', attrs={'class': 'color_class up-down-text green-color'})
        bse_open = float(result.find('strong', attrs={'class' : 'open'}).text.replace(',',''))
        bse_high = float(result.find('strong', attrs={'class' : 'high'}).text.replace(',',''))
        bse_low = float(result.find('strong', attrs={'class' : 'low'}).text.replace(',',''))
        bse_close = result.find('strong', attrs={'class' : 'prevclose'}).text.replace(',','')
        bse_val = float(bse.find('span', attrs={'class': 'lastprice'}).text)
        if abs(bse_val-bse_high) < abs(bse_val-bse_low):
            bse_high = bse_val
        else:
            bse_low = bse_val

        
        gold_url = 'https://economictimes.indiatimes.com/commoditysummary/symbol-GOLD.cms'
        res = requests.get(gold_url)        
        result = BeautifulSoup(res.content, "html5lib")
        gold_val = result.find('span', attrs={'class': 'commodityPrice'}).text
        
        crude_url = 'https://economictimes.indiatimes.com/commoditysummary/symbol-CRUDEOIL.cms'
        res = requests.get(crude_url)        
        result = BeautifulSoup(res.content, "html5lib")
        crude_val = result.find('span', attrs={'class': 'commodityPrice'}).text
        
        usd_url = 'https://economictimes.indiatimes.com/markets/forex/currency-converter/usd-to-inr'
        res = requests.get(usd_url)        
        result = BeautifulSoup(res.content, "html5lib")
        usd_val = result.find('span', attrs={'class': 'spotValue'}).text
        crude_val = str(round(float(crude_val)/float(usd_val),2))
        
        rightnow = time.time()
        utc = datetime.datetime.utcfromtimestamp(rightnow)
        ts = str(utc.timestamp())
        
        date = str(datetime.datetime.now()).split(".")[0]
        
        if(bse_high == bse_high_old and bse_open == bse_open_old and bse_low == bse_low_old and bse_close == bse_close_old and gold_val == gold_val_old and usd_val == usd_val_old and crude_val == crude_val_old):
            time.sleep(5)
            continue
        
        data = date + '*' + str(bse_open) + '*' + str(bse_high) + '*' + str(bse_low) + '*' + gold_val + '*' + usd_val + '*' + crude_val +  '*' + bse_close + '*' + ts
        publisher.publish(topic_name, bytes(data, 'utf-8'))
        print(data)
        
        bse_open_old = bse_open
        bse_close_old = bse_close
        bse_high_old = bse_high
        bse_low_old = bse_low
        usd_val_old = usd_val
        crude_val_old = crude_val
        gold_val_old = gold_val
        
        time.sleep(5)
    except:
        continue
    