import argparse
import csv
import logging
import numpy as np
import pandas as pd 
from sklearn.neighbors import KNeighborsClassifier
from sklearn import linear_model
from sklearn import  metrics
from sklearn.model_selection import train_test_split
from sklearn.metrics import accuracy_score
from sklearn.metrics import confusion_matrix
import apache_beam as beam
from apache_beam.metrics.metric import Metrics
from apache_beam.options.pipeline_options import PipelineOptions
from apache_beam.options.pipeline_options import SetupOptions

class Split(beam.DoFn):
    def process(self, element):
        Date,Open,High,Low,Close,volume = element.split(",")
        x_predict = [float(Open),float(High),float(Low)]
        x_predict = (np.asarray(x_predict)).reshape(1,-1)
        predictions = knn.predict(x_predict)
        print '\n\n\n00\n\n\n',predictions,'\n\n\n'
        return [{
            'Close': predictions
        }]

class CollectOpen(beam.DoFn):
    def process(self, element):
        # Returns a list of tuples containing Date and Open value
        result = [(element['Close'])]
        print result
        return result


def run(argv=None):
    stock = pd.read_csv("E:\\phd_data\\apache-beam-2.4.0\\sdks\\python\\apache_beam\\examples\\complete\\game\\stock\\train.csv")  
    print stock
    global knn
    knn = KNeighborsClassifier()
    array = stock.values
    X = array[:,1:4]
    Y = array[:,4]

    knn.fit(X,Y)

    parser = argparse.ArgumentParser()
    parser.add_argument('--input',type=str,
                        help='Input for the pipeline',
                        default='stock_test.csv')
    parser.add_argument('--output',
                        help='Output for the pipeline',
                        default='smit.txt')
    args, pipeline_args = parser.parse_known_args(argv)
    options = PipelineOptions(pipeline_args)
    input_filename = args.input
    output_filename = args.output
    with beam.Pipeline(options=options) as p:
        (p
         | 'ReadInputText' >> beam.io.ReadFromText(args.input,skip_header_lines=1)
         | 'Split' >> beam.ParDo(Split())
         | beam.ParDo(CollectOpen())
         | beam.io.textio.WriteToText(args.output))

if __name__ == '__main__':
    run()
